/*
    This file is part of COSINE.

    COSINE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    COSINE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with COSINE. If not, see <http://www.gnu.org/licenses/>.
 */
package at.ac.tuwien.vitalab.cosine;

import java.io.File;
import java.io.FileReader;
import java.util.LinkedList;

import org.ini4j.Ini;

import edu.wustl.mobilab.sliver.log.Logger;
import edu.wustl.mobilab.sliver.log.LoggerFactory;

/**
 * @author hpsaier
 * Should contain static methods for cosine package
 * general use.
 *
 */
/**
 * @author goldfish
 *
 */
public class Utils {
	/**
	 * logger
	 */
	private static Logger logger=
		LoggerFactory.getLogger(Utils.class);

	//NO constructor!
	
	
	/**
	 * j9 misses the String.split() method
	 * 
	 * @param toSplit
	 *            original String
	 * @param pattern
	 *            position of split
	 * @return [part1, part2] of original String
	 */
	public static String[] split2(String toSplit, String pattern) {
		LinkedList list = new LinkedList();
		String part1, part2 = "";

		part2 = toSplit; // just that while works
		while (part2.indexOf(pattern) >= 0) {
			part1 = part2.substring(0, part2.indexOf(pattern));
			part2 = part2.substring(part2.indexOf(pattern) + pattern.length());
			list.add(part1);
		}
		list.add(part2);

		String str[] = (String[]) list.toArray(new String[] {});

		return str;
	}
	/**
	 * representation of file - iniFileName in Ini structure
	 * @param iniFileName filename as String
	 * @return file as Ini object
	 */
	public static Ini readIniFiles(String iniFileName) throws Exception{
		File file;
		try {
			file = new File(System.getProperty("user.dir")
					+ System.getProperty("file.separator")
					+ iniFileName);
			/*System.out.println("iniContextFileName-Path: "
					+ file.getAbsolutePath());*/
			return new Ini(new FileReader(file));
		} catch (Exception e) { // should not happen @see prerequisits
			//e.printStackTrace();
			throw new Exception(e.getMessage());
		}
		//return null;
	}
	
	public static String[] stringtoArray( String s, String sep ) {
		  // convert a String s to an Array, the elements
		  // are delimited by sep
		  StringBuffer buf = new StringBuffer(s);
		  int arraysize = 1;
		  for ( int i = 0; i < buf.length(); i++ ) {
		    if ( sep.indexOf(buf.charAt(i) ) != -1 )
		      arraysize++;
		  }
		  String [] elements  = new String [arraysize];
		  int y,z = 0;
		  if ( buf.toString().indexOf(sep) != -1 ) {
		    while (  buf.length() > 0 ) {
		      if ( buf.toString().indexOf(sep) != -1 ) {
		        y =  buf.toString().indexOf(sep);
		        if ( y != buf.toString().lastIndexOf(sep) ) {
		          elements[z] = buf.toString().substring(0, y ); 
		          z++;
		          buf.delete(0, y + 1);
		        }
		        else if ( buf.toString().lastIndexOf(sep) == y ) {
		          elements[z] = buf.toString().substring
		            (0, buf.toString().indexOf(sep));
		          z++;
		          buf.delete(0, buf.toString().indexOf(sep) + 1);
		          elements[z] = buf.toString();z++;
		          buf.delete(0, buf.length() );
		        }
		      }
		    }
		  }
		  else {
		    elements[0] = buf.toString(); 
		  }
		  buf = null;
		  return elements;
		}
	
	/** "manual" string replacer for J9 
	 * @return replaced string
	 */
	public static String replace_string(String original, String replaceMe, String subsitute) {

		char[] string = original.toCharArray();
		char[] replace = replaceMe.toCharArray();
		char[] replaceWith = subsitute.toCharArray();

		StringBuffer sb = new StringBuffer();
		boolean found;
	    for (int i = 0; i < string.length; i++)
	    {

	        if(string[i] == replace[0] && string.length >= replace.length)
	        {
	            found = true;
	            for(int j = 0; j < replace.length; j++)
	            {
	                if(!(string[i + j] == replace[j]))
	                {
	                   found = false;
	                   break;
	                }
	            }
	            if(found)
	            {
	                sb.append(replaceWith);
	                i = i + (replace.length - 1);
	                continue;
	            }
	        }
	        sb.append(string[i]);
	    }
	    return sb.toString();
	}
}
