/*
    This file is part of COSINE.

    COSINE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    COSINE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with COSINE. If not, see <http://www.gnu.org/licenses/>.
 */
package at.ac.tuwien.vitalab.cosine.contextrouting;

import java.util.HashSet;
import java.util.Hashtable;

import at.ac.tuwien.vitalab.middleware.discovery.MissingServiceAttributeException;
import at.ac.tuwien.vitalab.middleware.discovery.ServiceInfo;

//TODO import at.ac.tuwien.vitalab.middleware.discovery.ServiceInfo;

public class ContextRoutingServiceInfo {

	/**
	 * original object
	 */
	private ServiceInfo serviceInfo;
	/**
	 * contextInfos uuid
	 */
	private String uuid;
	/**
	 * contextInfos uuid
	 */
	private String belongsTo;
	/**
	 * node type e.g. Worker, Leader, Team...
	 */	
	private String nodeType;
	

	private int ratio;
	
	//TODO remove
	private boolean DEBUG;
	
	private static Hashtable infoTable = new Hashtable(); 
	private Hashtable rating = new Hashtable(3);
	
	public final String RAND = "RAND";
	/**
	 * @param is ours!
	 */
	private ContextRoutingServiceInfo(String uuid){
		this.uuid = uuid;
	}

	public static ContextRoutingServiceInfo getInstance(String uuid) {
		ContextRoutingServiceInfo result;
		
		if (uuid == null) //don't do this!!!
			return null;

		result = (ContextRoutingServiceInfo) infoTable.get(uuid);
		if (result == null)
			result = new ContextRoutingServiceInfo(uuid); 
		
		infoTable.put(uuid, result);
		
		return result;
	}
	/**
	 * 
	 * @return TEST only
	 */
	private int generateRandomRatio() {
		int result = 0;
		java.util.Random rand = new java.util.Random();
		result = rand.nextInt(10);
		return result;
	}
	
	/**
	 * rating stuff
	 */
	public void updateRating(int type, int value) {
		updateRating(type,value,0,0);
	}
	
	public void updateRating(int type, int value, int min, int max) {
		int array [] = {value, min, max}; 		
		if (type == 10000)
			value = generateRandomRatio();
//		rating.put(new Integer(type), new Integer(value));
		rating.put(new Integer(type), array);		
	}	

	public Hashtable getRatingTable() {
		//update values changing currently
//		try {
//			rating.put(new Integer(ContextRoutingService.HOPS), new Integer(this.getServiceInfo().getHopsToHost()));
//		} catch (MissingServiceAttributeException e) {
//			// TODO Auto-generated catch block
//			//e.printStackTrace()
//		}
		
		return rating;
	}
	public int getRatingValue(int type) {
		return ((Integer) rating.get(new Integer(type))).intValue();
	}
	
	public ServiceInfo getServiceInfo() {
		return serviceInfo;
	}
	public void setServiceInfo(ServiceInfo serviceInfo) {
		this.serviceInfo = serviceInfo;
	}
	public String getUuid() {
		return uuid;
	}
	public void setUuid(String uuid) {
		this.uuid = uuid;
	}
	public String getBelongsTo() {
		return belongsTo;
	}
	public void setBelongsTo(String belongsTo) {
		this.belongsTo = belongsTo;
	}
	public String getNodeType() {
		return nodeType;
	}
	public void setNodeType(String nodeType) {
		this.nodeType = nodeType;
	}

	public int getRatio() {
		return ratio;
	}

	public boolean isOffline() {
		if (DEBUG)
			return false;
		
		return serviceInfo.isInactive();
	}

	//TODO
	public void setDebug()
	{
		DEBUG = true;
	}
}
