/*
    This file is part of COSINE.

    COSINE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    COSINE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with COSINE. If not, see <http://www.gnu.org/licenses/>.
 */
package at.ac.tuwien.vitalab.cosine.contextrouting;

import at.ac.tuwien.vitalab.cosine.rating.ARating;
import at.ac.tuwien.vitalab.middleware.discovery.ServiceInfo;

/**
 * @author hpsaier
 *
 */
public abstract class IContextRating {

	public final static ARating RATING_TYPE = null;
	/**
	 * TODO: 
	 * - weighting
	 */

	/**
	 * get rating for a rating type combine with a context provider
	 * @param type  
	 * @param info 
	 * @return current rating value
	 */
	public abstract double getRating(ARating type, ServiceInfo info);
	
	/** get all rating type values (sum) of a context provider
	 * @param info 
	 * @return sum of all values for this context provider
	 */
	public abstract double getRating(ServiceInfo info);
	
	/** return the amount of different ratings for a context source
	 * @param info
	 * @return
	 */
	public abstract int getNumberOfRatings(ServiceInfo info);
	/** set rating for a rating type and context provider with value
	 * @param type
	 * @param info
	 * @param value
	 */
	public abstract void setRating(ARating type, ServiceInfo info, double value);
	

}
