/*
    This file is part of COSINE.

    COSINE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    COSINE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with COSINE. If not, see <http://www.gnu.org/licenses/>.
 */
package at.ac.tuwien.vitalab.cosine.interfaces;

import at.ac.tuwien.vitalab.cosine.ContextData;

/**
 * Context data update receiver.
 * 
 * @author Lukasz Juszczyk
 *
 */
public interface IUpdateReceiverWS {

	/**
	 * Store/update context data. 
	 * 
	 * @param context Context data.
	 * 
	 * @throws Exception If the context data is invalid.
	 */
	public void storeContextInfo(ContextData context) 
	throws Exception;
}
