/*
    This file is part of COSINE.

    COSINE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    COSINE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with COSINE. If not, see <http://www.gnu.org/licenses/>.
 */
package at.ac.tuwien.vitalab.cosine.processing.storage;

import java.util.Vector;

import at.ac.tuwien.vitalab.cosine.ContextData;
import at.ac.tuwien.vitalab.cosine.interfaces.IContextHandler;
import at.ac.tuwien.vitalab.cosine.interfaces.IQueryProviderWS;
import at.ac.tuwien.vitalab.cosine.query.XQuery;

/**
 * Context Query handler.
 * 
 * @author Lukasz Juszczyk
 *
 */
public class QueryHandler implements IQueryProviderWS, IContextHandler {

	private ContextData contextData=null; 
	
	/* (non-Javadoc)
	 * @see at.ac.tuwien.vitalab.cosine.interfaces.IQueryProviderWS#getContextInfo(java.lang.String)
	 */
	public Vector getContextInfo(String query) throws Exception {
		
		Vector result=new Vector();
		
		if (contextData!=null) {

			if (query==null || query.length()==0 || query.equals(" ")) {
				result.add(contextData);
			} else {
				result.addAll(XQuery.returnMatches(contextData, query));				
			}			
		}
		return result;
	}

	/* (non-Javadoc)
	 * @see at.ac.tuwien.vitalab.cosine.processing.notification.RequestHandler#updateContext(at.ac.tuwien.vitalab.cosine.ContextData)
	 */
	public void updateContext(ContextData context) {
		contextData=context;
	}

}
