/*
    This file is part of RESCUE.

    RESCUE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    RESCUE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with RESCUE. If not, see <http://www.gnu.org/licenses/>.
 */
package at.ac.tuwien.vitalab.middleware.discovery;

/**
 * Interface for receivers of asynchronous callback messages.
 * 
 * @author Lukasz Juszczyk
 *
 */
public interface ICallbackReceiver {

	/**
	 * Callback function.
	 * 
	 * @param messageID ID of request message.
	 * @param response Response object. Can be an Exception.
	 */
	public void callback(String messageID, Object response);
	
	/**
	 * Notifies about an error during invocation.
	 * 
	 * @param messageID ID of request message.
	 * @param e Exception/error.
	 */
	public void error(String messageID, Exception e);
}
