/*
    This file is part of RESCUE.

    RESCUE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    RESCUE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with RESCUE. If not, see <http://www.gnu.org/licenses/>.
 */
package at.ac.tuwien.vitalab.middleware.discovery;

/**
 * Interface for receivers of service availability updates.
 * 
 * @author Lukasz Juszczyk
 *
 */
public interface IServiceUpdateReceiver {

	/**
	 * Called if a services becomes available (again).
	 * 
	 * @param service Service.
	 */
	public void serviceAvailable(ServiceInfo service);
	
	/**
	 * Called if a services becomes unavailable (again).
	 * 
	 * @param service Service.
	 */
	public void serviceUnavailable(ServiceInfo service);
	
}
