/*
    This file is part of RESCUE.

    RESCUE is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    RESCUE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with RESCUE. If not, see <http://www.gnu.org/licenses/>.
 */
package at.ac.tuwien.vitalab.middleware.soap;

/**
 * New SOAP fault, which does print out the error message correctly.
 * 
 * @author Lukasz Juszczyk
 *
 */
public class SoapFault extends org.ksoap2.SoapFault {

	private static final long serialVersionUID = 3772834950729269005L;

	/**
	 * Constructor.
	 * 
	 * @param msg Fault message.
	 */
	public SoapFault(String msg) {
		this.faultstring=msg;
	}
	
	/**
	 * Copy constructor.
	 * 
	 * @param fault Source.
	 */
	public SoapFault(org.ksoap2.SoapFault fault) {
		this.detail=fault.detail;
		this.faultactor=fault.faultactor;
		this.faultcode=fault.faultcode;
		this.faultstring=fault.faultstring;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Throwable#getLocalizedMessage()
	 */
	public String getLocalizedMessage() {
		return faultstring;
	}

	/* (non-Javadoc)
	 * @see java.lang.Throwable#getMessage()
	 */
	public String getMessage() {
		return faultstring;
	}
	
}
