package test;

import java.awt.*;
import java.awt.event.*;
import java.net.InetSocketAddress;
import java.util.Iterator;
import java.util.Hashtable;

class TestbedFrame extends Frame
{
	Color[] colors = new Color[]{Color.red, Color.orange, Color.yellow, Color.blue, Color.magenta, Color.white, Color.black, Color.gray};
	Hashtable ht = new Hashtable();
    // size of frame
    int X=300;
    int Y=300;
    // size of circle
    int w=20;
    int h=20;
    // initial co-ordinates of circle
    int x=0;
    int y=Y/2;
    public TestbedFrame(int height, int width)
    {
        setBackground(Color.green);
        setTitle("COSINE Testbed");
        // this code enables you to close the window
        addWindowListener(new WindowAdapter ()
            {
                public void windowClosing(WindowEvent e)
                {
                    System.exit(0);
                }
            });
        // set size of frame
        X=height;
        Y=width;
        x=X/2;
        y=Y/2;
        setSize(height,width);
        // and set its position on the screen
        setLocation(300,150);
        
    }
    
    private int transformCircleCoord(int value, int diameter){
    	int result = 0;
    	result = (int)((value+(X/2))-(diameter/2));
    	return result;
    }
        
    public void addCircle(String uuid, int x, int y, int h, int w, int color) {
//    	System.err.println("adding circle"+x+" "+y+" "+w+" "+h);
    	Circle circle = new Circle();
    	int diameter = h*2;
    	circle.x = transformCircleCoord(x,diameter);
    	circle.y = transformCircleCoord(y, diameter);
    	circle.w = diameter;
    	circle.h = diameter;
    	int colorPicker = color%colors.length;
    	circle.c = colors[colorPicker];
    	ht.put(uuid,circle);
    	repaint();
    }
	// over-ride paint() method of Frame class to paint graphics objects
        // this must be a public method
    public void paint(Graphics g)
    {
	// Draw a circle on the screen
    	for (Iterator it=ht.keySet().iterator(); it.hasNext();) {
    		String uuid = (String)it.next();
    		Circle circle = (Circle) ht.get(uuid);
			g.setColor(circle.c);
//			System.err.println("repainting: "+circle.x+" "+circle.y+" "+circle.h+" "+circle.w);

			g.drawOval(circle.x, circle.y, circle.h, circle.w);
			g.drawString(uuid, circle.x+circle.h/2, circle.y+circle.h/2);
			if (circle.connection != null) {
				g.drawLine(circle.x+circle.h/2, circle.y+circle.h/2, circle.connection.x+circle.h/2,circle.connection.y+circle.h/2);

			}

    	}
    }

    public void moveCircle()
    {
		// size and width of frame
		Dimension d = getSize();
		int W = d.width;
		// increment for moving circle on screen
		int incr = 3;
		//  calculate new x co-ordinates for circle
		if (x < W)
		    {
			x+=incr;
		    }
		else
		    {
			x=0;
		    }
		try
		    {
			// wait a while to smooth the display
			Thread.sleep(80);
		    }
		catch(InterruptedException e)
		    {	
		    }
		repaint();
    }
    private void drawConnection() {
    	Hashtable ht_help = new Hashtable();

    	for (Iterator it=ht.values().iterator(); it.hasNext();) {
    		Circle circle1 = (Circle)it.next();
    		for (Iterator it2=ht.keySet().iterator(); it2.hasNext();) {
    			String key = (String)it2.next();
    			Circle circle2 = (Circle) ht.get(key);
//				System.err.println(circle1+" "+circle2);    			
    			if (circle2.equals(circle1)) {
    				ht_help.put(key, circle2);
    				continue;
    			}
    			else if (circle2.x == circle1.x && circle2.y == circle1.y) { 
    				ht_help.put(key, circle2);
    				continue;
    			}
    			
    			if (doIntersect(circle1.x, circle1.y, circle2.x, circle2.y, circle1.h)) {
    				if (circle2.connection == null) {
        				circle2.connection = circle1;    					
    				}
    				else if ( 
    						circle2.connection.connection != null &&
    						circle2.connection.connection.equals(circle2))
        				circle2.connection = circle1;

    				
					ht_help.put(key, circle2);
    					
    			} else if (circle2.connection !=null && circle2.connection.equals(circle1)){
    				circle2.connection = null;
    				ht_help.put(key, circle2);    				
    			} else {
    				ht_help.put(key, circle2);
    			}
				//ht_help.put(key, circle2);				
    		}
    		
    	}
    	ht = ht_help;
    	
    }
    
    private boolean doIntersect(int x1, int y1, int x2, int y2, int diameter) {
    	int x, y, z;
    	if (x1 > x2) {
    		x = (x1-x2);    		
    	} else {
    		x = (x2-x1);    		
    	}
    	if (y1 > y2) {
    		y = (y1 -y2);
    	} else {
    		y = (y2-y1);
    	}
    	//pythagoras says so!
    	x=x*x;
    	y=y*y;
    	z=x+y;
    	z=(int)Math.sqrt(z);
    	if (z <= diameter/2)
    		return true;
    	else 
    		return false;
    }
    public void moveCircle(String uuid, int x, int y)
    {
    	Circle circle = (Circle)ht.get(uuid);
System.out.println();
    	// size and width of frame
		//Dimension d = getSize();
		//int W = d.width;
		// increment for moving circle on screen
		//int incr = 3;
		//  calculate new x co-ordinates for circle
//		if (circle.x < W)
//		    {
//			circle.x+=x;
//		    }
//		else
//		    {
//			circle.x=0;
//		    }
    	circle.x=transformCircleCoord(x, circle.h);
    	circle.y=transformCircleCoord(y, circle.h);
		try
		    {
			// wait a while to smooth the display
			Thread.sleep(80);
		    }
		catch(InterruptedException e)
		    {	
		    }
		ht.put(uuid,circle);
		drawConnection();
		repaint();
    }
    
    class Circle {
    	int x;
    	int y;
    	int w;
    	int h;
    	Color c;
    	Circle connection;
    	public String toString() {
    		return "set("+x+","+y+","+h+","+w+") Color: "+c.toString()+" connected to: "+connection;
    	}
    }


    public static void main (String [] args)
    { 
    	TestbedFrame f = new TestbedFrame(200,200);
        f.setVisible(true);
	for (int i=0;i<1000;++i)
	    {
		f.moveCircle();
	    }
    }
}
