/*
    This file is part of sensors developed for Vimoware.

    It is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    It is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with it. If not, see <http://www.gnu.org/licenses/>.
 */

package at.ac.tuwien.vitalab.sensors.workpad;


import at.ac.tuwien.vitalab.cosine.ContextData;

/**
 * Abstract Sensor class.
 * 
 * @author Atif Manzoor
 * @author Lukasz Juszczyk
 *
 */
public abstract class ASensor {

	public static final String WORKPAD_SENSOR_NS=ContextData.NAMESPACE;

	/**
	 * Returns the type name of the context data provided by the sensor.
	 * 
	 * @return Type name.
	 */
	public abstract String getSensorTypeName();

	/**
	 * Returns the type namespace of the context data provided by the sensor.
	 * 
	 * @return Type namespace.
	 */
	public String getSensorTypeNamespace() {
		return WORKPAD_SENSOR_NS;
	}

	/**
	 * Returns the context data of this sensor.
	 * 
	 * @return Context data.
	 * @throws Exception If errors occur.
	 */
	public abstract ContextData getContextDataXML() throws Exception;
}
