/*
    This file is part of sensors developed for Vimoware.

    It is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    It is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with it. If not, see <http://www.gnu.org/licenses/>.
 */
package at.ac.tuwien.vitalab.sensors.workpad;

//import com.intel.mobile.battery.BatteryClass;
//import com.intel.mobile.battery.BatteryCollection;
//import com.intel.mobile.battery.BatteryInstance;

import at.ac.tuwien.vitalab.cosine.ContextData;

/**
 * Battery Sensor.
 * 
 * @author Atif Manzoor
 * @author Lukasz Juszczyk
 *
 */
public class BatterySensor extends ASensor {

	private double capacityInMin=60.0;
	
	private long timestampOfInit=System.currentTimeMillis();
	
	/**
	 * Constructor.
	 *
	 */
	public BatterySensor() {
	}
	
	/* (non-Javadoc)
	 * @see at.ac.tuwien.vitalab.sensors.workpad.ASensor#getContextDataXML()
	 */
	public ContextData getContextDataXML() throws Exception {
		
    	ContextData contextData = new ContextData(this.getSensorTypeName(), 
    			this.getSensorTypeNamespace());
    	
//    	BatteryClass batteryClass = new BatteryClass();
//        BatteryCollection batteryCollection = 
//        	(BatteryCollection)batteryClass.GetInstances();
//        
//
//		if (!batteryCollection.HasNext() ) {
//		    return contextData;
//		}
//        
//        while (batteryCollection.HasNext()) {        	
//            BatteryInstance batteryInstance = 
//            	(BatteryInstance)batteryCollection.Next();
//            
//            if ( !batteryInstance.EstimatedTimeRemaining.IsNull() ) {
//                long tr = batteryInstance.EstimatedTimeRemaining.GetValue();
//                long trhr = tr / 3600;
//                long trmin = (tr - trhr * 3600) / 60;
//                contextData.setAttribute(null, "minutesLeft", ""+trmin);
//            }
//            if ( !batteryInstance.PercentRemaining.IsNull() ) {
//                int value = batteryInstance.PercentRemaining.GetValue();            
//                contextData.setAttribute(null, "percentLeft", ""+value);   
//            }
//        }
        
    	int minutesLeft=0;
    	int percentLeft=0;
    	    	
    	double minutesPassed=
    		(double)(System.currentTimeMillis()-timestampOfInit)/(1000.0*60.0);
    	
    	percentLeft=(int)((capacityInMin-minutesPassed)*100/capacityInMin);
    	
    	minutesLeft=(int)Math.max(capacityInMin-minutesPassed,0);
    	
    	contextData.setAttribute(null, "minutesLeft", ""+minutesLeft);
    	contextData.setAttribute(null, "percentLeft", ""+percentLeft);
    	
    	return contextData;		
	}

	/* (non-Javadoc)
	 * @see at.ac.tuwien.vitalab.sensors.workpad.ASensor#getSensorTypeName()
	 */
	public String getSensorTypeName() {
		return "Battery";
	}

}
