/*
    This file is part of sensors developed for Vimoware.

    It is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    It is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with it. If not, see <http://www.gnu.org/licenses/>.
 */
package at.ac.tuwien.vitalab.sensors.workpad;

import java.util.Random;

//import Location.GeoPoint;
import at.ac.tuwien.vitalab.cosine.ContextData;

/**
 * GPS Location Sensor.
 * 
 * @author Atif Manzoor
 * @author Lukasz Juszczyk
 *
 */
public class LocationSensor extends ASensor {

	private float lon=0.0f;
	private float lat=0.0f;
	private float alt=0.0f;

	private Random rand=new Random();
	
	private float lonMod=(rand.nextFloat()/100.0f)*(rand.nextBoolean()?1f:-1f);
	private float latMod=(rand.nextFloat()/100.0f)*(rand.nextBoolean()?1f:-1f);
	private float altMod=Math.abs(rand.nextFloat())/1000.0f;

	
//	private GeoPoint gp;
	
	/**
	 * Constructor.
	 *
	 */
	public LocationSensor() {

		
//		gp = new GeoPoint();
	}
	
	/* (non-Javadoc)
	 * @see at.ac.tuwien.vitalab.sensors.workpad.ASensor#getContextDataXML()
	 */
	public ContextData getContextDataXML() throws Exception {
		
//		String str = gp.getGeoLocation();
//		ContextData	locationData = new ContextData(str);
		
		ContextData	contextData = new ContextData(this.getSensorTypeName(),
				this.getSensorTypeNamespace());
		
//		contextData.setName(this.getSensorTypeName());
//		contextData.setNamespace(this.getSensorTypeNamespace());
//
//		for (int i=0;i<locationData.getAttributeCount();i++) {
//			String attName=locationData.getAttributeName(i);			
//			attName=attName.toLowerCase();
//			String attValue=locationData.getAttributeValue(i);
//			
//			if (attName.startsWith("lat") || attName.startsWith("long") || 
//					attName.startsWith("alt")) {
//				
//				contextData.setAttribute(null, attName,attValue);
//			} 
//		}

//		contextData.setAttribute(null, "lattitude","0");
//		contextData.setAttribute(null, "longitude","0");
//		contextData.setAttribute(null, "altitude","0");

		lon+=lonMod;
		lat+=latMod;
		alt+=altMod;
		
		contextData.setAttribute(null, "latitude",""+lat);
		contextData.setAttribute(null, "longitude",""+lon);
		contextData.setAttribute(null, "altitude",""+alt);
		return contextData;
	}

	/* (non-Javadoc)
	 * @see at.ac.tuwien.vitalab.sensors.workpad.ASensor#getSensorTypeName()
	 */
	public String getSensorTypeName() {
		return "GeoLocation";
	}

}
