declare execution sequential;
declare namespace soap = "http://schemas.xmlsoap.org/wsdl/soap/";
declare namespace ns = "http://schemas.xmlsoap.org/wsdl/";
declare namespace s = "http://www.w3.org/2001/XMLSchema";


declare variable $wsdl external;

(:
declare variable $wsdl := doc("xquerypTests/normal/inputData/testWSDL2.xml");
:)

<services>
{
	for $service in $wsdl/ns:definitions/ns:service/ns:port
	let $tns := $wsdl/ns:definitions/@targetNamespace
	where $service/soap:address
	return
		<service address="{$service/soap:address/@location}">
		{
			let $binding := $wsdl/ns:definitions/ns:binding[@name eq mxq:deletePrefix($service/@binding)]
			let $portType := $wsdl/ns:definitions/ns:portType[@name eq mxq:deletePrefix($binding/@type)]
			for $operation in $binding/ns:operation
			return
				let $portOperation := $portType/ns:operation[@name eq $operation/@name]
				let $requestMsg := $wsdl/ns:definitions/ns:message[@name eq mxq:deletePrefix($portOperation/ns:input/@message)]
				let $responseMsg := $wsdl/ns:definitions/ns:message[@name eq mxq:deletePrefix($portOperation/ns:output/@message)]
				return
					<function
						name="{$operation/@name}"
						soapaction="{$operation/soap:operation/@soapAction}"
						inputnamespace="{$tns}"
						inputencoding="{$operation/ns:input/soap:body/@encodingStyle}"
						outputnamespace="{$tns}"
						outputencoding="{$operation/ns:output/soap:body/@encodingStyle}"
						responseelement="{
							if (exists($responseMsg/ns:part/@element)) then
								""
							else
								$responseMsg/ns:part/@name
						}">
					{
						for $param in $requestMsg/ns:part
						return
							if (exists($param/@type)) then
								<param name="{$param/@name}" type="{$param/@type}" />
							else if (exists($param/@element)) then
								<param name="" />
								(:
								let $element := $wsdl/ns:definitions/ns:types/s:schema/s:element[@name eq mxq:deletePrefix($param/@element)]
								return
									if (exists($element/@type)) then
										<param name="{$element/@name}" type="{$element/@type}"/>
									else
										<param name="{$element/@name}" />
								:)
							else
								<param name="{$param/@name}" />
								
					}
					</function>
		}
		</service>
}
</services>